#define		DATA_DDR			DDRA
#define		DATA_PORT			PORTA
#define		DATA_IN				PINA			//D0..D7

#define		ADDR_DDR			DDRC
#define		ADDR_PORT			PORTC			//D8..D15
#define		ADDR_IN				PINC

#define		CTRL_DDR			DDRB
#define		CTRL_PORT			PORTB

#define		CTRL_A0				PB0		//	DA0
#define		CTRL_A1				PB1		//	DA1
#define		CTRL_A2				PB2		//	DA2

#define		CTRL_A3				PB3		//	CS0
#define		CTRL_A4				PF4		//  CS1

#define		CTRL_WR				PB5
#define		CTRL_RD				PB6
#define		CTRL_RST			PB7

#define		CS_1				0x10
#define		CS_0				0x08
#define		DA_2				0x04
#define		DA_1				0x02
#define		DA_0				0x01

#define		CTRL_A				0x08
#define		CMD_A				0x10		//0b1001 0000 first bit 1 = Reset;
											//     1      command bit

// ATA status register bits
#define SR_BUSY					0x80
#define SR_DRDY					0x40
#define SR_DF					0x20
#define SR_DSC					0x10
#define SR_DRQ					0x08
#define SR_CORR					0x04
#define SR_IDX					0x02
#define SR_ERR					0x01


// Command registers
#define CMD_DATA				0x00
#define CMD_ERROR				0x01
#define CMD_FEATURES			0x01
#define CMD_SECT_CNT			0x02
#define CMD_SECT_NUM			0x03
#define CMD_CYL_LOW				0x04
#define CMD_CYL_HIGH			0x05
#define CMD_DEV_HEAD			0x06
#define CMD_STATUS				0x07
#define CMD_COMMAND				0x07

// Used ATAPI Commands
#define ATAPI_PACKET			0xa0
#define ATAPI_IDENTIFY			0xa1
#define ATAPI_READ12			0xa8
#define ATAPI_SLOWDOWN			0xbb

#define ATAPI_START_STOP_UNIT	0x1b

#define ATAPI_DOOR_LOCK			0x1e
#define ATAPI_REQUEST_SENSE		0x03
#define ATAPI_RESET				0x08
#define ATAPI_MODE_SENSE		0x5A

// Control registers
#define CTRL_ALT_STAT			0x06
#define CTRL_DEV_CTRL			0x06

// ATA dev/head register bits
#define DH_CHS0					0xA0
#define DH_CHS1					0xB0

//ATAPI CMD ERRORS
#define CD_STAT_OK				0x00
#define CD_STAT_ERROR			0x01
#define CD_STAT_NODISK			0x02
#define CD_STAT_UNDEF_ERROR		0x04
#define CD_STAT_NOT_READY		0x08
#define CD_STAT_OPENED			0x18

// Bytes per sector
#define BPS 					2048

#define LOAD_CD					3
#define EJECT_CD				2
#define START_CD				1
#define STOP_CD					0

#define			IDLE			0
#define			STOP			1
#define			PLAY			2
#define			BACK			3
#define			NEXT			4
#define			EJECT			5	
#define			SEARCH			6
#define			PAUSE			7
#define 		FIND			8

struct u16_bit
{
	uint8_t low, 
			high;
};

union u16_convert
{
	uint16_t 	value;
	struct 	u16_bit bytes;
};

void 		CD_Cmd(uint8_t Funct);
void 		init_port (void);
void 		ATA_HW_Reset (void);

uint8_t 	ATA_Init (void);
uint8_t 	LoadCD (void);
uint16_t 	dirlist (void);

void 		LCD_Disc_Time(uint8_t *des);
void 		Do_Eject (void);
uint8_t  	ATAPI_DA_GetSubC (void);
uint16_t  	ATAPI_DA_GetCurTime (void);
uint8_t  	ATAPI_DA_GetCurTrack (void);
uint8_t  	ATAPI_DA_PlayMSF(uint8_t m, uint8_t s, uint8_t f);
uint8_t  	ATAPI_DA_Play(uint8_t Track);
uint8_t  	ATAPI_DA_Stop(void);
uint8_t  	ATAPI_DA_PauseResume (uint8_t bResume);



