#ifndef _LCD_H
#define _LCD_H

#include <inttypes.h>


#define	LCD_DDR					DDRD
#define LCD_PORT                PORTD
#define LCD_ENABLE_PIN          0
#define LCD_RS_PIN         	    3
#define LCD_CLOCK_PIN           4


#define	LCD_FUNCTION_SET		0x38
#define LCD_ON					0x0c		//no currsor
#define LCD_MODE_SET			0x06
#define LCD_CLEAR				0x01


#define	STRDSPLMAX				17
#define	DSPL_LEFT				0
#define	DSPL_CENTER				1
#define	DSPL_RIGHT				2

/* functions */
void init_lcd (void);
void lcd_clear (uint8_t line);
void lcd_gotoxy (uint8_t x, uint8_t y);
void lcd_printf (uint8_t *string,char nAligh);

void lcd_putc (uint8_t c);
void lcd_load_byte  (uint8_t out_byte);
void LCD_Write_cmd  (uint8_t dat);
void LCD_Write_data (uint8_t dat);


#endif

